<template>
  <lightning-card>
    <div slot="title">
      <div class="slds-grid">
        <div class="slds-col slds-size_1-of-3">
          <div class="slds-float_left">
            <img src={youSignLogoRsrc} class="yousignlogo" />
          </div>
        </div>
        <div class="slds-col slds-size_1-of-3">
          <div class="slds-align_absolute-center">
            <h2 class="slds-modal__title slds-hyphenate">{label.popupTitle}</h2>
          </div>
        </div>
        <div class="slds-col slds-size_1-of-3">&nbsp;</div>
      </div>
    </div>
    <div class="slds-align_absolute-center" if:true={isLoading}>
      <div class="loadingPlaceholder">
        <lightning-spinner
          alternative-text="Loading"
          size="medium"
        ></lightning-spinner>
        <div class="slds-text-heading_small" style="margin-top: 80px">
          {label.loading}
        </div>
      </div>
    </div>
    <template if:false={_iframeDisplayed}>
      <ul
        class="slds-has-dividers_bottom slds-has-block-links_space"
        if:false={isLoading}
      >
        <li class="slds-item">
          <c-yousign-file-selector
            files={files}
            selected-files={selectedFiles}
            required
          ></c-yousign-file-selector>
        </li>
        <li if:true={isTemplateAvailable} class="slds-item">
          <div class="slds-p-top_medium">
            <label class="slds-form-element__label" for="combobox">
              Template
            </label>
            <div class="slds-form-element__control">
              <div class="slds-select_container">
                <select
                  class="slds-select"
                  onchange={selectionTemplateChangeHandler}
                >
                  <option value="">--</option>
                  <template for:each={templateOptions} for:item="option">
                    <option
                      key={option.label}
                      class="uiInputSelectOption"
                      value={option.value}
                    >
                      {option.label}
                    </option>
                  </template>
                </select>
              </div>
            </div>
          </div>
        </li>
        <li class="slds-item">
          <div class="slds-p-top_medium">
            <c-yousign-lookup-lwc
              onselectionchange={handleSelectContact}
              onsearch={handleSearchContact}
              label={label.contactLabel}
              placeholder={label.lookupPlaceholder}
              disabled={computedDisabledContactSelection}
              selection={selectedContacts}
              errors={contactErrors}
              is-multi-entry
              required
            ></c-yousign-lookup-lwc>
          </div>
          <div class="slds-p-top_small">
            <template iterator:it={selectedContacts}>
              <c-yousign-ordered-contact-list
                key={it.value.id}
                is-first={it.first}
                is-last={it.last}
                index={it.index}
                roles-list={contactRoleOptions}
                max-index={selectedContacts.length}
                contact={it.value.sObjectValues}
                disable-reordering={disableContactReordering}
                onmoveitem={handleChangeContactOrder}
                ondeleteitem={handleDeleteContact}
                onselectionchange={handleRoleAssignement}
              ></c-yousign-ordered-contact-list>
            </template>
          </div>
        </li>
        <li class="slds-item" if:false={hideAdvancedOptions}>
          <div class="slds-p-top_medium">
            <lightning-layout>
              <lightning-layout-item padding="around-small">
                <lightning-input
                  type="toggle"
                  label={label.orderContacts}
                  checked={computedContactOrderingEnabled}
                  onchange={handleContactOrderingToggle}
                  disabled={isSubmitted}
                ></lightning-input>
              </lightning-layout-item>
              <lightning-layout-item padding="around-small">
                <lightning-input
                  type="toggle"
                  label="Draft"
                  checked={isDraft}
                  onchange={handleDraftToggle}
                  disabled={isSubmitted}
                ></lightning-input>
              </lightning-layout-item>
            </lightning-layout>
          </div>
        </li>
      </ul>
    </template>
    <template if:true={_iframeDisplayed}>
      <iframe
        src={computedIframeUrl}
        allowfullscreen
        style={computedIframeStyle}
      ></iframe>
    </template>
    <div slot="footer">
      <div class="slds-clearfix">
        <div class="slds-float_right">
          <lightning-button
            label={label.backButton}
            title={label.backButton}
            onclick={handleClickBack}
            class="slds-m-left_x-small"
          ></lightning-button>
          <lightning-button
            label={label.showProcedureButton}
            title={label.showProcedureButton}
            onclick={handleClickShowProcedure}
            if:true={showProcedureButtonEnabled}
            class="slds-m-left_x-small"
          ></lightning-button>
          <lightning-button
            variant="brand"
            label={computedSubmitButtonLabel}
            title={computedSubmitButtonLabel}
            onclick={handleClickSubmit}
            class="slds-m-left_x-small"
            if:false={isSubmitted}
          ></lightning-button>
          <lightning-button
            variant="brand"
            label={label.cancelButton}
            title={label.cancelButton}
            onclick={handleClickCancel}
            class="slds-m-left_x-small"
            if:true={isCancellable}
          ></lightning-button>
        </div>
      </div>
    </div>
  </lightning-card>
</template>